"use strict";
exports.__esModule = true;
exports.withLoader = void 0;
var tslib_1 = require("tslib");
var react_1 = (0, tslib_1.__importDefault)(require("react"));
var useDebounce_1 = require("./hooks/useDebounce");
var RTKLoader_1 = require("./RTKLoader");
var withLoader = function (Component, args) {
    return function (props) {
        var _a, _b, _c;
        var useLoaderArgs = [];
        if (args.queriesArg) {
            useLoaderArgs.push(args.queriesArg(props));
        }
        var debouncedQueryArgs = (0, useDebounce_1.useDebounce)(useLoaderArgs, (_a = args.debounce) !== null && _a !== void 0 ? _a : 0);
        var query = args.useLoader.apply(args, (args.debounce
            ? debouncedQueryArgs
            : useLoaderArgs));
        return (react_1["default"].createElement(RTKLoader_1.RTKLoader, { query: query, loader: (_b = args.onLoading) === null || _b === void 0 ? void 0 : _b.call(args, props), onError: args.onError
                ? function (error) {
                    var _a, _b;
                    return (_b = (_a = args.onError) === null || _a === void 0 ? void 0 : _a.call(args, props, error, query)) !== null && _b !== void 0 ? _b : react_1["default"].createElement(react_1["default"].Fragment, null);
                }
                : undefined, onSuccess: function (data) { return Component(props, data); }, onFetching: (_c = args === null || args === void 0 ? void 0 : args.onFetching) === null || _c === void 0 ? void 0 : _c.call(args, props, query.data
                ? function () { return Component(props, query.data); }
                : function () { return react_1["default"].createElement(react_1["default"].Fragment, null); }) }));
    };
};
exports.withLoader = withLoader;
//# sourceMappingURL=withLoader.js.map