import React from "react";
import { useDebounce } from "./hooks/useDebounce";
import { RTKLoader } from "./RTKLoader";
export var withLoader = function (Component, args) {
    return function (props) {
        var _a, _b, _c;
        var useLoaderArgs = [];
        if (args.queriesArg) {
            useLoaderArgs.push(args.queriesArg(props));
        }
        var debouncedQueryArgs = useDebounce(useLoaderArgs, (_a = args.debounce) !== null && _a !== void 0 ? _a : 0);
        var query = args.useLoader.apply(args, (args.debounce
            ? debouncedQueryArgs
            : useLoaderArgs));
        return (React.createElement(RTKLoader, { query: query, loader: (_b = args.onLoading) === null || _b === void 0 ? void 0 : _b.call(args, props), onError: args.onError
                ? function (error) {
                    var _a, _b;
                    return (_b = (_a = args.onError) === null || _a === void 0 ? void 0 : _a.call(args, props, error, query)) !== null && _b !== void 0 ? _b : React.createElement(React.Fragment, null);
                }
                : undefined, onSuccess: function (data) { return Component(props, data); }, onFetching: (_c = args === null || args === void 0 ? void 0 : args.onFetching) === null || _c === void 0 ? void 0 : _c.call(args, props, query.data
                ? function () { return Component(props, query.data); }
                : function () { return React.createElement(React.Fragment, null); }) }));
    };
};
//# sourceMappingURL=withLoader.js.map